import { BasicKeyHandler } from 'tde-datagrid';
import { getKeyboardLayout } from '@lumino/keyboard';
export class RichKeyHandler extends BasicKeyHandler {
    onKeyDown(grid, event) {
        const key = getKeyboardLayout().keyForKeydownEvent(event);
        if (key === 'Backspace' || key === 'Delete') {
            event.stopPropagation();
            event.preventDefault();
            this.onDelete(grid, event);
            return;
        }
        super.onKeyDown(grid, event);
    }
    onDelete(grid, event) {
        // Fetch the selection.
        const selection = grid.selectionModel.currentSelection();
        // Fetch the dataModel.
        const model = grid.dataModel;
        // Compute an update for the model.
        const update = model.clearCells('body', selection);
        // Emit the change to the editor.
        model.onChangedSignal.emit(update);
    }
}
//# sourceMappingURL=keyhandler.js.map